
datablock fxDtsBrickData(LogicGate_Rom32x32_Data){
	brickFile = $LuaLogic::Path @ "bricks/gen/newbricks/ROM 32x32.blb";
	iconName = $LuaLogic::Path @ "bricks/gen/newicons/ROM 32x32";
	
	category = "Logic Bricks";
	subCategory = "Special I/O";
	uiName = "ROM 32x32";
	logicUIName = "ROM 32x32";
	logicUIDesc = "";
	
	hasPrint = 1;
	printAspectRatio = "Logic";
	
	logicBrickSize = "32 32 1";
	orientationFix = 3;
	
	isLogic = true;
	isLogicGate = true;
	isLogicInput = false;
	
	logicInit = 
		"return function(gate) " @
		"	gate.romdata = {} " @
		"	for i = 0, 1023 do " @
		"		gate.romdata[i] = false " @
		"	end " @
		"end"
	;
	logicInput = 
		"return function(gate, args) " @
		"	local data = args[1] " @
		"	for i = 1, #data do " @
		"		local c = data:sub(i, i) " @
		"		gate.romdata[i-1] = (c==\"1\") " @
		"	end " @
		"	Gate.queue(gate, 0) " @
		"end"
	;
	logicUpdate = 
		"return function(gate) " @
		"	if Gate.getportstate(gate, 12) then " @
		"		Gate.setportstate(gate, 11, gate.romdata[( " @
		"			(Gate.getportstate(gate, 1) and 1 or 0) " @
		"			+ (Gate.getportstate(gate, 2) and 2 or 0) " @
		"			+ (Gate.getportstate(gate, 3) and 4 or 0) " @
		"			+ (Gate.getportstate(gate, 4) and 8 or 0) " @
		"			+ (Gate.getportstate(gate, 5) and 16 or 0) " @
		"			+ (Gate.getportstate(gate, 6) and 32 or 0) " @
		"			+ (Gate.getportstate(gate, 7) and 64 or 0) " @
		"			+ (Gate.getportstate(gate, 8) and 128 or 0) " @
		"			+ (Gate.getportstate(gate, 9) and 256 or 0) " @
		"			+ (Gate.getportstate(gate, 10) and 512 or 0) " @
		"		)]) " @
		"	else " @
		"		Gate.setportstate(gate, 11, false) " @
		"	end " @
		"end"
	;
	logicGlobal = "";
	
	numLogicPorts = 12;
	
	isLogicRom = true;
	logicRomY = 32;
	logicRomX = 32;
	
	logicPortType[0] = 1;
	logicPortPos[0] = "31 -31 0";
	logicPortDir[0] = 3;
	logicPortUIName[0] = "Addr0";
	logicPortCauseUpdate[0] = true;
	
	logicPortType[1] = 1;
	logicPortPos[1] = "29 -31 0";
	logicPortDir[1] = 3;
	logicPortUIName[1] = "Addr1";
	logicPortCauseUpdate[1] = true;
	
	logicPortType[2] = 1;
	logicPortPos[2] = "27 -31 0";
	logicPortDir[2] = 3;
	logicPortUIName[2] = "Addr2";
	logicPortCauseUpdate[2] = true;
	
	logicPortType[3] = 1;
	logicPortPos[3] = "25 -31 0";
	logicPortDir[3] = 3;
	logicPortUIName[3] = "Addr3";
	logicPortCauseUpdate[3] = true;
	
	logicPortType[4] = 1;
	logicPortPos[4] = "23 -31 0";
	logicPortDir[4] = 3;
	logicPortUIName[4] = "Addr4";
	logicPortCauseUpdate[4] = true;
	
	logicPortType[5] = 1;
	logicPortPos[5] = "21 -31 0";
	logicPortDir[5] = 3;
	logicPortUIName[5] = "Addr5";
	logicPortCauseUpdate[5] = true;
	
	logicPortType[6] = 1;
	logicPortPos[6] = "19 -31 0";
	logicPortDir[6] = 3;
	logicPortUIName[6] = "Addr6";
	logicPortCauseUpdate[6] = true;
	
	logicPortType[7] = 1;
	logicPortPos[7] = "17 -31 0";
	logicPortDir[7] = 3;
	logicPortUIName[7] = "Addr7";
	logicPortCauseUpdate[7] = true;
	
	logicPortType[8] = 1;
	logicPortPos[8] = "15 -31 0";
	logicPortDir[8] = 3;
	logicPortUIName[8] = "Addr8";
	logicPortCauseUpdate[8] = true;
	
	logicPortType[9] = 1;
	logicPortPos[9] = "13 -31 0";
	logicPortDir[9] = 3;
	logicPortUIName[9] = "Addr9";
	logicPortCauseUpdate[9] = true;
	
	logicPortType[10] = 0;
	logicPortPos[10] = "31 31 0";
	logicPortDir[10] = 1;
	logicPortUIName[10] = "Out";
	
	logicPortType[11] = 1;
	logicPortPos[11] = "31 -31 0";
	logicPortDir[11] = 2;
	logicPortUIName[11] = "In";
	logicPortCauseUpdate[11] = true;
	
};

function LogicGate_Rom32x32_Data::Logic_onAdd(%data, %brick) {
	lualogic_rom_updatedata(%brick);
}
